## mingw-w64-ghdl-5.1.1-3.src.tar.zst

=== pyGHDL/dom/requirements.txt ===
-r ../libghdl/requirements.txt

pyVHDLModel ~= 0.31
#https://github.com/VHDL/pyVHDLModel/archive/dev.zip#pyVHDLModel

=== pyGHDL/libghdl/requirements.txt ===
pyTooling[terminal] ~= 8.5

=== src/verilog/Makefile ===
PNODES=../../scripts/pnodes.py
PNODESRS=../../scripts/pnodesrs.py
PNODES_ARGS=--field-file=verilog-nodes.adb.in --kind-file=verilog-nodes.ads --node-file=verilog-nodes.ads --template-file=verilog-nodes.adb.in --meta-basename=verilog-nodes_meta --kind-type=Nkind --kind-range-prefix=Nkinds_ --kind-prefix=N_ --node-type=Node

all: verilog-nodes.adb verilog-nodes_meta.ads verilog-nodes_meta.adb \
  nodes_def.rs

verilog-nodes.adb: verilog-nodes.adb.in verilog-nodes.ads $(PNODES)
	$(RM) -f $@
	$(PNODES) $(PNODES_ARGS) body > $@
	chmod a-w $@

verilog-nodes_meta.ads: verilog-nodes_meta.ads.in verilog-nodes.ads $(PNODES)
	$(RM) -f $@
	$(PNODES) $(PNODES_ARGS) meta_specs > $@
	chmod a-w $@

verilog-nodes_meta.adb: verilog-nodes_meta.adb.in verilog-nodes.ads $(PNODES)
	$(RM) -f $@
	$(PNODES) $(PNODES_ARGS) --keep-order meta_body > $@
	chmod a-w $@

nodes_def.rs: $(PNODESRS) verilog-nodes.ads
	$(RM) $@
	$(PNODESRS) $(PNODES_ARGS) verilog-nodes > $@
	chmod -w $@

standard_def.rs: $(PNODESRS) verilog-standard.ads
	$(RM) $@
	$(PNODESRS) $(PNODES_ARGS) verilog-standard > $@
	chmod -w $@

=== src/vhdl/Makefile ===
#  Copyright (C) 2002 - 2015 Tristan Gingold
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <gnu.org/licenses>.

# Some files are automatically generated using pnodes.py
# This Makefile can be used to regenerate these files.  Generated files must
# be committed and distribued with the sources, so that users don't need to
# regenerate them (and don't need to have python installed).

PNODES=../../scripts/pnodes.py
PNODESPY=../../scripts/pnodespy.py
PNODESRS=../../scripts/pnodesrs.py
PYTHON=python3

DEPS=vhdl-nodes.ads vhdl-nodes.adb.in $(PNODES)

GEN_FILES=vhdl-nodes.adb \
  vhdl-nodes_meta.ads \
  vhdl-nodes_meta.adb \
  vhdl-elocations.adb \
  vhdl-elocations_meta.ads \
  vhdl-elocations_meta.adb \
  ../../pyGHDL/libghdl/vhdl/nodes.py \
  ../../pyGHDL/libghdl/vhdl/nodes_meta.py \
  ../../pyGHDL/libghdl/vhdl/tokens.py \
  ../../pyGHDL/libghdl/vhdl/elocations.py \
  ../../pyGHDL/libghdl/errorout.py \
  ../../pyGHDL/libghdl/std_names.py \
  ../errorout_def.rs \
  ../std_names.rs \
  nodes_def.rs

NODES_FLAGS=--node-file=vhdl-nodes.ads --field-file=vhdl-nodes.adb.in \
  --template-file=vhdl-nodes.adb.in --kind-file=vhdl-nodes.ads \
  --meta-basename=vhdl-nodes_meta

ELOCATIONS_FLAGS=--node-file=vhdl-elocations.ads \
  --field-file=vhdl-elocations.adb.in --kind-file=vhdl-nodes.ads \
  --template-file=vhdl-elocations.adb.in --meta-basename=vhdl-elocations_meta

all: $(GEN_FILES)

vhdl-nodes.adb: vhdl-nodes.adb.in $(DEPS)
	$(RM) $@
	$(PNODES) $(NODES_FLAGS) body > $@
	chmod -w $@

vhdl-nodes_meta.ads: vhdl-nodes_meta.ads.in $(DEPS)
	$(RM) $@
	$(PNODES) $(NODES_FLAGS) meta_specs > $@
	chmod -w $@

vhdl-nodes_meta.adb: vhdl-nodes_meta.adb.in $(DEPS)
	$(RM) $@
	$(PNODES) $(NODES_FLAGS) meta_body > $@
	chmod -w $@

vhdl-elocations.adb: vhdl-elocations.adb.in vhdl-elocations.ads $(DEPS)
	$(RM) $@
	$(PNODES) $(ELOCATIONS_FLAGS) body > $@
	chmod -w $@

vhdl-elocations_meta.ads: vhdl-elocations_meta.ads.in vhdl-elocations.ads $(DEPS)
	$(RM) $@
	$(PNODES) $(ELOCATIONS_FLAGS) meta_specs > $@
	chmod -w $@

vhdl-elocations_meta.adb: vhdl-elocations_meta.adb.in vhdl-elocations.ads $(DEPS)
	$(RM) $@
	$(PNODES) $(ELOCATIONS_FLAGS) meta_body > $@
	chmod -w $@

../../pyGHDL/libghdl/vhdl/nodes.py: $(DEPS) $(PNODESPY)
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-nodes > $@
	$(PYTHON) -m black $@
	chmod -w $@

../../pyGHDL/libghdl/vhdl/nodes_meta.py: $(DEPS) $(PNODESPY)
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-meta > $@
	$(PYTHON) -m black $@
	chmod -w $@

../../pyGHDL/libghdl/std_names.py: $(PNODESPY) $(PNODES) ../std_names.ads
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-names > $@
	$(PYTHON) -m black $@
	chmod -w $@

../../pyGHDL/libghdl/vhdl/tokens.py: $(PNODESPY) $(PNODES) vhdl-tokens.ads
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-tokens > $@
	$(PYTHON) -m black $@
	chmod -w $@

../../pyGHDL/libghdl/vhdl/elocations.py: $(PNODESPY) $(PNODES) vhdl-elocations.ads
	$(RM) $@
	$(PNODESPY) $(ELOCATIONS_FLAGS) libghdl-elocs > $@
	$(PYTHON) -m black $@
	chmod -w $@

../../pyGHDL/libghdl/errorout.py: $(PNODESPY) $(PNODES) ../errorout.ads
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-errorout > $@
	$(PYTHON) -m black $@
	chmod -w $@

../errorout_def.rs: $(PNODESRS) $(PNODES) ../errorout.ads
	$(RM) $@
	$(PNODESRS) $(NODES_FLAGS) errorout > $@
	chmod -w $@

../std_names.rs: $(PNODESRS) $(PNODES) ../std_names.ads
	$(RM) $@
	$(PNODESRS) $(NODES_FLAGS) std_names > $@
	chmod -w $@

nodes_def.rs: $(PNODESRS) $(DEPS)
	$(RM) $@
	$(PNODESRS) $(NODES_FLAGS) vhdl-nodes > $@
	chmod -w $@

clean:
	$(RM) -f $(GEN_FILES)

=== src/ortho/debug/Makefile ===
#  -*- Makefile -*- for the ortho-code back-end
#  Copyright (C) 2005 Tristan Gingold
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <gnu.org/licenses>.
BE=debug
ortho_srcdir=..

orthobe_srcdir=$(ortho_srcdir)/$(BE)

GNATMAKE=gnatmake
CC=gcc
CFLAGS=-g
ALL_GNAT_FLAGS=-pipe -g -gnato -gnatwaeu -gnatf -gnaty3befhkmr
GNATMAKE_FLAGS=$(ALL_GNAT_FLAGS) $(GNATFLAGS) -aI$(ortho_srcdir) -aI$(orthobe_srcdir) -aI.
SED=sed

all: $(ortho_exec)


$(ortho_exec): force $(ortho_srcdir)/$(BE)/ortho_debug.ads
	$(GNATMAKE) -o $@ $(GNATMAKE_FLAGS) ortho_debug-main \
	 $(GNAT_BARGS) -largs $(LDFLAGS) $(GNATLFLAGS)

clean:
	$(RM) -f *.o *.ali *~ b~*.ad? ortho_nodes-main
	$(RM) ortho_debug.ads

force:

ORTHO_BASENAME=ortho_debug

# Automatically build ortho_debug.ads from ortho_node.common.ads and
# ortho_debug.private.ads
include $(ortho_srcdir)/Makefile.inc

=== PKGBUILD ===
_realname=ghdl
pkgbase="mingw-w64-${_realname}"
pkgname=(
  "${MINGW_PACKAGE_PREFIX}-${_realname}-llvm"
  "${MINGW_PACKAGE_PREFIX}-${_realname}-mcode"
)
pkgver=5.1.1
pkgrel=3
pkgdesc='GHDL: the open-source analyzer, compiler, simulator and (experimental) synthesizer for VHDL'
arch=('any')
mingw_arch=('mingw64' 'ucrt64')
url='https://github.com/ghdl/ghdl'
license=('spdx:GPL-2.0-or-later')
groups=("${MINGW_PACKAGE_PREFIX}-eda")
depends=(
  "${MINGW_PACKAGE_PREFIX}-cc-libs"
  "${MINGW_PACKAGE_PREFIX}-gcc-ada"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-clang"
  "${MINGW_PACKAGE_PREFIX}-llvm"
  "${MINGW_PACKAGE_PREFIX}-autotools"
)
checkdepends=("${MINGW_PACKAGE_PREFIX}-python-pytest")
options=(!emptydirs)
source=("https://github.com/ghdl/ghdl/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        001-support-llvm-21.patch::https://github.com/ghdl/ghdl/commit/560a822c.patch)
sha256sums=('00cd58ec8f25e2532465aabc8705f43071f20dc1d13e03fd9dc235523186fca9'
            '0228cc3694dc6438419073e94bdca7f4dc0334d23f2428e3aeb1171db1763ef5')

prepare() {
  cd ${_realname}-${pkgver}
  patch -p1 -i "${srcdir}"/001-support-llvm-21.patch
}

build() {
  echo "Building ghdl-llvm..."
  mkdir -p "${srcdir}"/build-${MSYSTEM}-llvm && cd "${srcdir}"/build-${MSYSTEM}-llvm

  CC=clang \
  CXX=clang++ \
  MSYS2_ARG_CONV_EXCL="--prefix" \
  ../${_realname}-${pkgver}/configure \
    --prefix=${MINGW_PREFIX} \
    --enable-checks \
    --enable-libghdl \
    --enable-synth \
    --with-llvm-config

  make GNATMAKE="gnatmake -j$(nproc)"

  echo "Building ghdl-mcode..."
  mkdir -p "${srcdir}"/build-${MSYSTEM}-mcode && cd "${srcdir}"/build-${MSYSTEM}-mcode

  MSYS2_ARG_CONV_EXCL="--prefix" \
  ../${_realname}-${pkgver}/configure \
    --prefix=${MINGW_PREFIX} \
    --enable-checks \
    --enable-libghdl \
    --enable-synth

  make GNATMAKE="gnatmake -j$(nproc)"
}

check() {
  cd "${srcdir}/build-${MSYSTEM}-llvm"
  make install.vpi.local
  make test
}

package_ghdl-llvm() {
  pkgdesc+=" (LLVM backend) (mingw-w64)"
  depends+=("${MINGW_PACKAGE_PREFIX}-llvm-libs")
  provides=("${MINGW_PACKAGE_PREFIX}-${_realname}")
  cd "${srcdir}"/build-${MSYSTEM}-llvm
  make DESTDIR="${pkgdir}" install

  local PREFIX_DEPS=$(cygpath -am ${MINGW_PREFIX})
  sed -s "s|${PREFIX_DEPS}|${MINGW_PREFIX}|g" -i "${pkgdir}"${MINGW_PREFIX}/lib/libghdl.link
  sed -s "s|${PREFIX_DEPS}|${MINGW_PREFIX}|g" -i "${pkgdir}"${MINGW_PREFIX}/lib/ghdl/grt.lst

  # License
  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/doc/licenses.rst "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}-llvm/licenses.rst
}

package_ghdl-mcode() {
  pkgdesc+=" (mcode backend) (mingw-w64)"
  depends+=("${MINGW_PACKAGE_PREFIX}-zlib")
  conflicts=("${MINGW_PACKAGE_PREFIX}-ghdl-llvm")
  cd "${srcdir}"/build-${MSYSTEM}-mcode
  make DESTDIR="${pkgdir}" install

  local PREFIX_DEPS=$(cygpath -am ${MINGW_PREFIX})
  sed -s "s|${PREFIX_DEPS}|${MINGW_PREFIX}|g" -i "${pkgdir}"${MINGW_PREFIX}/lib/libghdl.link

  # License
  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/doc/licenses.rst "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}-mcode/licenses.rst
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;

=== dist/msys2/mcode/PKGBUILD ===
_realname=ghdl
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}-mcode")
provides=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=$(sed -n -e '/^ghdl_version/s/ghdl_version="\(.*\)"/\1/p' ../../../configure | sed 's/-/./g')
pkgrel=1
pkgdesc="GHDL: the open-source analyzer, compiler, simulator and (experimental) synthesizer for VHDL (mcode backend) (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url='https://github.com/ghdl/ghdl'
license=('spdx:GPL-2.0-or-later')
groups=("${MINGW_PACKAGE_PREFIX}-eda")
# libgnat.dll is needed for libghdl.
depends=(
  "${MINGW_PACKAGE_PREFIX}-gcc-ada"
  "${MINGW_PACKAGE_PREFIX}-zlib"
)
makedepends=
checkdepends=
options=(!emptydirs)

build() {
  echo "build() [SKIP] No build. Pre-compiled artifact will be used."
  echo "build() pwd=$(pwd)"
}

package() {
  echo "package() [CHECK] List artifact contents ..."
  echo "package() pwd=$(pwd)"
  echo "--------------------------------------------------------------------------------"
  echo "ls -lAh ../../../../install"
  ls -lAh ../../../../install
  echo "--------------------------------------------------------------------------------"

  mkdir -p "${pkgdir}${MINGW_PREFIX}"
  cp -v -R ../../../../install/* ${pkgdir}/${MINGW_PREFIX}

  local PREFIX_DEPS=$(cygpath -am ${MINGW_PREFIX})
  sed -s "s|${PREFIX_DEPS}|${MINGW_PREFIX}|g" -i "${pkgdir}"${MINGW_PREFIX}/lib/libghdl.link

#   # License
#   install -Dm644 "${srcdir}"/${_realname}-${pkgver}/doc/licenses.rst "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}-mcode/licenses.rst


  echo "--------------------------------------------------------------------------------"
  ls -lAh ${pkgdir}
  echo "--------------------------------------------------------------------------------"
  ls -lAh ${pkgdir}/${MINGW_PREFIX}
  echo "--------------------------------------------------------------------------------"
  ls -lAh ${pkgdir}/${MINGW_PREFIX}/bin
  echo "--------------------------------------------------------------------------------"
  ls -lAh ${pkgdir}/${MINGW_PREFIX}/lib
  echo "--------------------------------------------------------------------------------"
}
